import ListView, {AbsAdapter} from "./ListView";
import ListItemComp from "./ListItemComp";

const {ccclass, property} = cc._decorator;

@ccclass
export default class Helloworld extends cc.Component {

    @property(ListView)
    listView: ListView = null;

    @property(cc.Label)
    tipLabel: cc.Label = null;

    start() {
        // 可以是其他的复杂对象数据.这里为了演示,仅使用数字数据.
        const data: number[] = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24];

        const adapter = new ListAdapter()
        adapter.setDataSet(data);
        this.listView.setAdapter(adapter);

        // 可选功能.
        this.listView.pullDown(() => {
            console.log("你已经上拉到最顶端了.");
            this.tipLabel.string = "你已经上拉到最顶端了.";
        }, this);
        this.listView.pullUp(() => {
            console.log("你已经下拉到最底端了.");
            this.tipLabel.string = "你已经下拉到最底端了";
        }, this);
    }
}

class ListAdapter extends AbsAdapter {
    updateView(item: cc.Node, posIndex: number) {
        let comp = item.getComponent(ListItemComp);
        if (comp) {
            comp.setData(this.getItem(posIndex));
        }
    }
}
